
* EXAMPLE 11 - ADD SEVERAL VARIABLES TO A DATA SET USING A CNTLIN DATA SET;

data selectssns / view=selectssns;
length label $ 18.;
retain fmtname 'addmany';
infile 'k:\epi697\data\getssnsb.dat' end=last;
if last then do;
   hlo = 'o';
   label = 'X';
   output;
end;
input start : comma11. gender : $1. zip : $5. salary : $10.;  
label = catx('/',gender,zip,salary);  
output;
drop gender zip salary;
run;

title "OBSERVATIONS IN CNTLIN DATA SET 'SELECTSSNS'";
proc print data=selectssns (obs=5); 
run;

proc format cntlin=selectssns;
run;

data goodssns (drop=info);
length gender $1 zip $5; 
infile 'k:\epi697\data\lotassns.dat';
input ssn comma11. record 6.;
info = put(ssn,addmany.);  
if info ne: 'X';  
gender = scan(info,1,'/');  
zip    = scan(info,2,'/');
salary = input(scan(info,3,'/'),best.);  
format ssn ssn. salary dollar10.;
run;

title 'EXAMPLE 11 - RECORD SELECTION PLUS ADD THREE VARIABLES USING A CNTLIN DATA SET';
proc print data=goodssns (obs=10);
var ssn record gender zip salary;
run;

*****************************************************************;

proc datasets lib=work memtype=view nolist;
delete selectssns;
quit;

*****************************************************************;

* use an INDEX;

data selectssns (index=(ssn));
infile 'k:\epi697\data\getssnsb.dat';
input ssn : comma11. gender : $1. zip : $5. salary;  
run;

data goodssns;  
infile 'k:\epi697\data\lotassns.dat';
input ssn comma11. record 6.;
set selectssns key=ssn / unique; 
if _error_ then _error_ = 0;
else output;
format ssn ssn. salary dollar10.;
run;

title 'EXAMPLE 11 - USE AN INDEX';
proc print data=goodssns (obs=10);
var ssn record gender zip salary;
run;

*****************************************************************;

proc datasets lib=work nolist;
delete selectssns;
quit;

*****************************************************************;

* use a HASH data set object;

data selectssns;
infile 'k:\epi697\data\getssnsb.dat';
input ssn : comma11. gender : $1. zip : $5. salary;  
run;

data goodssns; 
*if 0 then set selectssns; 
declare hash s (dataset:'selectssns');
s.definekey ('ssn');
s.definedata ('gender','zip','salary');
s.definedone();

infile 'k:\epi697\data\lotassns.dat' end=done;
do until (done);
   input ssn comma11. record 6.;
   if not s.find() then output;
end;

stop;
format ssn ssn. salary dollar10.;
run;

title 'EXAMPLE 11 - USE A HASH DATA STEP OBJECT';
proc print data=goodssns (obs=10);
var ssn record gender zip salary;
run;

*****************************************************************;

proc datasets lib=work nolist;
delete selectssns;
quit;

*****************************************************************;

data selectssns;
infile 'k:\epi697\data\getssnsb.dat';
input ssn : comma11. gender : $1. zip : $5. salary;  
run;

proc sql noprint;
select quote(strip(name)) into :variables separated by ','
from dictionary.columns
where libname eq 'WORK' and memname eq 'SELECTSSNS';
quit;

%put &variables;

data goodssns; 
if 0 then set selectssns; 
declare hash s (dataset:'selectssns');
s.definekey ('ssn');
s.definedata (&variables);
s.definedone();

infile 'k:\epi697\data\lotassns.dat' end=done;
do until (done);
   input ssn comma11. record 6.;
   if not s.find() then output;
end;

stop;
format ssn ssn. salary dollar10.;
run;

title 'EXAMPLE 11 - USE A HASH DATA STEP OBJECT ... USE A MACRO VARIABLE TO DEFINEDATA';
proc print data=goodssns (obs=10);
var ssn record gender zip salary;
run;

*****************************************************************;

proc datasets lib=work nolist;
delete selectssns;
quit;

*****************************************************************;
