
* 
RECORD SELECTION ALTERNATIVE WHEN MATCHING VARIABLE IS NUMERIC
 AND MAGNITUDE OF MATCHING VARIABLE IS NOT TOO BIG
;

* large data set ... ID numbers 1 through 1,000,000;
data fake;
do id=1 to 1e6;
   age = ceil(100*ranuni(123));
   output;
end;
run;

* smaller data set ... 1,000 ID numbers to find in thelarge data set;
data sample;
do j=1 to 1000;
   id = ceil(1e6*ranuni(123));
   output;
end;
drop j;
run;

******************************************************;

* USE AN INDEX;

proc datasets lib=work;
modify sample;
index create id;
quit;

data found;
set fake;
set sample key=id / unique;
if _error_ then _error_ = 0;
else output;
run;

title 'USE AN INDEX';
proc print data=found (obs=20);
run;

******************************************************;

* USE A HASH DATA STEP OBJECT;

data found;
declare hash s (dataset:'sample');
s.definekey ('id');
s.definedone();

do until (done);
   set fake end=done;
   if not s.find() then output;
end;

stop;
run;

title 'USE A HASH DATA STEP OBJECT';
proc print data=found (obs=20);
run;

******************************************************;

* USE AN ARRAY;

data found;
* populate an array with a 1 for each ID in small data set;
array s(1000000) _temporary_;
do until(done1);
   set sample end=done1;
   s(id) = 1;
end;

* select observations using the array;
do until (done2);
   set fake end=done2;
   if s(id) then output;
end;
run;

title 'USE AN ARRAY';
proc print data=found (obs=20);
run;
